<template>
  <div class="h-100 min-h-screen bg-gray-900">
    <div>
      <swole-header></swole-header>
      <div
        class="flex flex-col items-start items-center justify-center w-full w-full p-2 px-4 lg:p-12"
      >
        <div
          class="px-6 text-white text-center rounded-lg border border-gray-300 mb-2 w-11/12 py-2 lg:w-4/5 lg:py-16"
        >
          <div
            class="flex flex-col items-start items-center justify-center w-full w-full"
          >
            <h1 class="font-bold text-4xl lg:pb-8 pb-2 inline">
              {{ exercises[index]?.name }}
              <svg
                @click="openModal({ exercise: exercises[index] })"
                xmlns="http://www.w3.org/2000/svg"
                class="h-6 w-6 pb-2 inline"
                viewBox="0 0 20 20"
                fill="currentColor"
              >
                <path
                  fill-rule="evenodd"
                  d="M18 10a8 8 0 11-16 0 8 8 0 0116 0zm-8-3a1 1 0 00-.867.5 1 1 0 11-1.731-1A3 3 0 0113 8a3.001 3.001 0 01-2 2.83V11a1 1 0 11-2 0v-1a1 1 0 011-1 1 1 0 100-2zm0 8a1 1 0 100-2 1 1 0 000 2z"
                  clip-rule="evenodd"
                />
              </svg>
            </h1>
            <h2 class="font-bold text-3xl lg:pb-8 pb-2">
              Set {{exercises[index]?.set}} / {{ sets }}
            </h2>
            <h2 class="font-bold text-3xl lg:pb-8 pb-2">Reps x5</h2>
            <h3 class="font-bold text-2xl lg:pb-8 pb-2 text-white">Set Time: {{ setTimerMinutes }}:{{ setTimerSeconds }}</h3>
        </div>
          <img
            :src="exercises[index]?.image"
            class="mx-auto bg-gray-300 h-1/4 my-2 lg:my-6"
          />
          <h3 v-if="length != index + 1" class="font-bold text-2xl lg:pb-8 pb-2">Next {{ exercises[index + 1]?.name }} - Set {{exercises[index + 1]?.set}}</h3>
          <button
            v-if="index != 0"
            @click="previous"
            class="uppercase border border-gray-100 text-center text-sm mt-10 px-12 py-2 rounded-md font-bold bg-primary-very-light text-primary-blue"
          >
            Previous
          </button>
          <button
            v-if="length != index + 1"
            @click="next"
            class="uppercase border border-gray-100 text-center text-sm mt-10 px-12 py-2 rounded-md font-bold bg-primary-very-light text-primary-blue"
          >
            Next
          </button>
          <button
            v-if="length == index + 1"
            @click="finish"
            class="uppercase border border-gray-100 text-center text-sm mt-10 px-12 py-2 rounded-md font-bold bg-primary-very-light text-primary-blue"
          >
            Finish
          </button>

        </div>
        <div>
          <h3 class="font-bold text-2xl lg:pb-8 pb-2 text-white">Time: {{ totalMinutes }}:{{ totalSeconds }}</h3>
        </div>


      </div>
    </div>
  </div>
</template>

<script>
import { computed, onMounted, watchEffect } from "vue";
import { useRouter } from "vue-router";
import { useStore } from "vuex";
import SwoleHeader from "@/components/SwoleHeader.vue";
import { useExercise } from "@/hooks";
import { useTimer, useStopwatch } from 'vue-timer-hook';
import { vibrate } from "@/utils";

export default {
  name: "Exercise",
  components: {
    SwoleHeader,
  },
  setup() {
    const setTime = 120;
    const currentTimestamp = () => {
      return new Date().setSeconds(new Date().getSeconds() + setTime);
    }
    const router = useRouter();
    const store = useStore();
    const stopwatch = useStopwatch(true);
    const timer = useTimer(currentTimestamp());

    onMounted(() => {
      watchEffect(async () => {
        if(timer.isExpired.value) {
            vibrate();
            next();
        }
      })
    })

    const {
      current,
      setIndex,
      timing,
    } = useExercise();
    timing.start = Date.now();

    if(current.exercises.length === 0){
      router.push("/");
    }

    const finish = () => {
      timing.finish = Date.now();
      timing.time = timing.finish - timing.start;
      stopwatch.pause();
      timer.pause();
      router.push("/finish");
    }

    const openModal = ({ exercise = {} }) => {
      store.dispatch("setModalMessage", {
        title: exercise?.name,
        message: exercise?.desc,
        open: true,
      });
    };

    const next = () => {
      const nextIndex = current.index + 1;
      if (nextIndex < current.exercises.length) {
          setIndex({ index: nextIndex });
      }
      timer.restart(currentTimestamp());
    }

    const previous = () => {
      const previousIndex = current.index - 1;
      if (previousIndex < current.exercises.length && previousIndex >= 0) {
          setIndex({ index: previousIndex });
      }
      timer.restart(currentTimestamp());
    }

    return {
      open,
      setTimerSeconds: computed(() => { return timer.seconds.value >= 10 ? timer.seconds.value.toString() : `0${timer.seconds.value.toString()}`}),
      setTimerMinutes: computed(() => { return timer.minutes.value >= 10 ? timer.minutes.value.toString() : `0${timer.minutes.value.toString()}`}),
      totalSeconds: computed(() => { return stopwatch.seconds.value >= 10 ? stopwatch.seconds.value.toString() : `0${stopwatch.seconds.value.toString()}`}),
      totalMinutes: computed(() => { return stopwatch.minutes.value >= 10 ? stopwatch.minutes.value.toString() : `0${stopwatch.minutes.value.toString()}`}),
      exercises: computed(() => { return current.exercises.length > 0 ? current.exercises : []; }),
      sets: computed(() => { return current.sets }),
      index: computed(() => { return current.index }),
      length: computed(() => { return current.exercises.length }),
      openModal,
      finish,
      next,
      previous,
    };
  },
};
</script>
